﻿'----------------------------------------------------------
'
' FK/Ⅱ用サンプルコード
'
' 開発環境
'     Microsoft Visual Studio 2010
'     Version 10.0.30319.1 RTMRel
'     Microsoft .NET Framework
'     Version 4.5.51209 RTMRel
'
' Copyright (c) 2015 TAKASAGO.LTD.All Right Reserved.
'
' 2015/06/18 Created. [H.O.]
'
'----------------------------------------------------------
Public Class Form1
    Dim intLoad As Integer       'ロード状態 (0=OFF,1=ON)
    Dim strMode As String        '動作モード (CC=定電流,CV=定電圧,CR=定抵抗,CP=定電力)
    Dim dblVolt As Double        '負荷電圧
    Dim dblCurr As Double        '負荷電流
    Dim dblPow As Double         '負荷電力
    Dim dblRes As Double         '負荷抵抗
    Dim strVoltRng As String     '電圧レンジ (L=Lレンジ,H=Hレンジ)
    Dim strCurrRng As String     '電流レンジ (L=Lレンジ,H=Hレンジ)
    Dim dblCurrLim As Double     '電流リミッタ
    Dim dblPowLim As Double      '電力リミッタ
    Dim dblLowVoltLim As Double  '低電圧リミッタ
    Dim dblMeasVolt As Double    '計測電圧
    Dim dblMeasCurr As Double    '計測電流
    Dim dblMeasPow As Double     '計測電力
    Dim srtRcvData As String     '受信文字列

    '------------------------------------------------------
    'フォームロード
    '------------------------------------------------------
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        '通信設定
        With SerialPort1
            .PortName = "COM1"                      'ポート番号指定
            .BaudRate = 9600                        'ボーレート指定
            .DataBits = 8                           'データビット指定
            .Parity = IO.Ports.Parity.None          'パリティ指定
            .StopBits = IO.Ports.StopBits.One       'ストップビット指定
            .Handshake = IO.Ports.Handshake.None    'フロー制御指定
        End With

        Try
            'ポートオープン
            SerialPort1.Open()
        Catch ex As Exception
        End Try

        '初期値設定
        ComboBox1.SelectedItem = "CC"
        RadioButton2.Checked = True
        RadioButton4.Checked = True

        If SerialPort1.IsOpen = True Then
            Data_Send("ADDR 1")                     'デバイスアドレス指定コマンド送信
            srtRcvData = Data_Receive()             'データ受信
            '受信タイムアウト判定
            If TMO_Check() = True Then Exit Sub
            '受信文字列判定
            If RcvSt_Check() = True Then Exit Sub

            Data_Send("ALM:CLE")                    'アラームクリアコマンド送信
            srtRcvData = Data_Receive()             'データ受信
            '受信タイムアウト判定
            If TMO_Check() = True Then Exit Sub
            '受信文字列判定
            If RcvSt_Check() = True Then Exit Sub
        Else
            'ポートオープン失敗
            Me.Text = "サンプルコード(オフライン)"
        End If

    End Sub

    '------------------------------------------------------
    'フォームクローズ
    '------------------------------------------------------
    Private Sub Form1_FormClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.FormClosed

        'ポートクローズ
        SerialPort1.Close()

    End Sub

    '------------------------------------------------------
    'データ送信処理
    '引数：送信データ
    '------------------------------------------------------
    Private Sub Data_Send(ByVal strData As String)

        Try
            '送信データ書き込み
            SerialPort1.Write(strData & ControlChars.NewLine) 'NewLine(デリミタ)を付加して送信
        Catch ex As Exception
        End Try

    End Sub

    '------------------------------------------------------
    'データ受信処理
    '戻り値：受信文字列
    '------------------------------------------------------
    Private Function Data_Receive() As String
        Dim intRcvTMOCnt As Integer = 0 '受信タイムアウトカウント

        Data_Receive = "" '戻り値初期化

        Do
            'ウェイト処理(10ms)、レスポンス受信待ち
            System.Threading.Thread.Sleep(10)
            Try
                '受信バッファ内のデータバイト数の取得
                Dim bytGetData As Byte() = New Byte(SerialPort1.BytesToRead - 1) {}
                'データバイト数のバイト配列への書き込み
                SerialPort1.Read(bytGetData, 0, bytGetData.GetLength(0))
                '受信データ結合
                Data_Receive = Data_Receive + System.Text.Encoding.GetEncoding("SHIFT-JIS").GetString(bytGetData)
            Catch ex As Exception
            End Try

            '改行コード(CR+LF)の受信確認
            If Data_Receive.Contains(ControlChars.NewLine) Then
                '改行コード(CR+LF)を受信した場合、ループ処理を抜ける
                Exit Do
            Else
                '受信タイムアウトカウント+1
                intRcvTMOCnt = intRcvTMOCnt + 1
            End If
        Loop Until 5 <= intRcvTMOCnt '50ms経過した場合、ループ処理を抜ける

    End Function

    '------------------------------------------------------
    'Button1_Clickイベント(表示更新)
    '------------------------------------------------------
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Data_Send("MEAS:VOLT?")              '計測電圧取得コマンド送信
        srtRcvData = Data_Receive()          'データ受信
        '受信タイムアウト判定
        If TMO_Check() = False Then
            dblMeasVolt = Val(srtRcvData)    '受信文字列変換(String→Double)
            Label1.Text = dblMeasVolt        '計測電圧表示
        End If

        Data_Send("MEAS:CURR?")              '計測電流取得コマンド送信
        srtRcvData = Data_Receive()          'データ受信
        '受信タイムアウト判定
        If TMO_Check() = False Then
            dblMeasCurr = Val(srtRcvData)    '受信文字列変換(String→Double)
            Label2.Text = dblMeasCurr        '計測電流表示
        End If

        Data_Send("MEAS:POW?")               '計測電力取得コマンド送信
        srtRcvData = Data_Receive()          'データ受信
        '受信タイムアウト判定
        If TMO_Check() = False Then
            dblMeasPow = Val(srtRcvData)     '受信文字列変換(String→Double)
            Label3.Text = dblMeasPow         '計測電力表示
        End If

    End Sub

    '------------------------------------------------------
    'Button2_Clickイベント(設定値送信)
    '------------------------------------------------------
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        If RadioButton1.Checked = True Then
            strVoltRng = "H"
        Else
            strVoltRng = "L"
        End If
        Data_Send("VOLT:RANG " & strVoltRng)        '電圧レンジ設定コマンド送信
        srtRcvData = Data_Receive()                 'データ受信
        TMO_Check()                                 '受信タイムアウト判定

        If RadioButton3.Checked = True Then
            strCurrRng = "H"
        Else
            strCurrRng = "L"
        End If
        Data_Send("CURR:RANG " & strCurrRng)        '電流レンジ設定コマンド送信
        srtRcvData = Data_Receive()                 'データ受信
        TMO_Check()                                 '受信タイムアウト判定

        strMode = ComboBox1.SelectedItem
        Data_Send("FUNC:MODE " & strMode)           '動作モード設定コマンド送信
        srtRcvData = Data_Receive()                 'データ受信
        TMO_Check()                                 '受信タイムアウト判定

        Select Case strMode
            Case "CC"
                dblCurr = Val(TextBox1.Text)        'テキストボックス入力文字変換(String→Double)
                Data_Send("CURR " & dblCurr)        '負荷電流設定コマンド送信
            Case "CV"
                dblVolt = Val(TextBox1.Text)        'テキストボックス入力文字変換(String→Double)
                Data_Send("VOLT " & dblVolt)        '負荷電圧設定コマンド送信
            Case "CR"
                dblRes = Val(TextBox1.Text)         'テキストボックス入力文字変換(String→Double)
                Data_Send("RES " & dblRes)          '負荷抵抗設定コマンド送信
            Case "CP"
                dblPow = Val(TextBox1.Text)         'テキストボックス入力文字変換(String→Double)
                Data_Send("POW " & dblPow)          '負荷電力設定コマンド送信
        End Select
        srtRcvData = Data_Receive()                 'データ受信
        TMO_Check()                                 '受信タイムアウト判定

        dblCurrLim = Val(TextBox2.Text)             'テキストボックス入力文字変換(String→Double)
        Data_Send("CURR:PROT " & dblCurrLim)        '電流リミッタ設定コマンド送信
        srtRcvData = Data_Receive()                 'データ受信
        TMO_Check()                                 '受信タイムアウト判定

        dblPowLim = Val(TextBox3.Text)              'テキストボックス入力文字変換(String→Double)
        Data_Send("POW:PROT " & dblPowLim)          '電力リミッタ設定コマンド送信
        srtRcvData = Data_Receive()                 'データ受信
        TMO_Check()                                 '受信タイムアウト判定

        dblLowVoltLim = Val(TextBox4.Text)          'テキストボックス入力文字変換(String→Double)
        Data_Send("VOLT:PROT:UND " & dblLowVoltLim) '低電圧リミッタ設定コマンド送信
        srtRcvData = Data_Receive()                 'データ受信
        TMO_Check()                                 '受信タイムアウト判定

    End Sub

    '------------------------------------------------------
    'Button3_Clickイベント(LOAD ON設定)
    '------------------------------------------------------
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click

        intLoad = 1
        Data_Send("LOAD ON")              'ロードON設定コマンドの送信
        srtRcvData = Data_Receive()       'データ受信
        TMO_Check()                       '受信タイムアウト判定

    End Sub

    '------------------------------------------------------
    'Button4_Clickイベント(LOAD OFF設定)
    '------------------------------------------------------
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click

        intLoad = 0
        Data_Send("LOAD OFF")             'ロードOFF設定コマンドの送信
        srtRcvData = Data_Receive()       'データ受信
        TMO_Check()                       '受信タイムアウト判定

    End Sub

    '------------------------------------------------------
    '受信タイムアウト判定
    '戻り値：True=タイムアウト発生
    '        False=タイムアウトなし
    '------------------------------------------------------
    Private Function TMO_Check() As Boolean

        TMO_Check = False

        If srtRcvData = "" Then
            '受信タイムアウト発生
            Me.Text = "サンプルコード(オフライン)"
            TMO_Check = True
        End If

    End Function

    '------------------------------------------------------
    '受信文字列判定
    '戻り値：True=通信異常発生
    '        False=通信異常なし
    '------------------------------------------------------
    Private Function RcvSt_Check() As Boolean

        RcvSt_Check = False

        If srtRcvData.Contains("OK") Then
            Me.Text = "サンプルコード(オンライン)"
        Else
            '通信異常発生
            Me.Text = "サンプルコード(オフライン)"
            RcvSt_Check = True
        End If

    End Function
End Class
